* Dies ist die Steuerdatei zum Ausdruck einer Wochenabrechnung auf ein
* Formular. Die Angaben in den einzelnen Zeilen dieser Datei sind codiert
* und werden von Spesenprogramm eingelesen, decodiert und ausgefhrt.
* Die einzelnen Zeilen dieser Datei werden anhand des 1. Zeichens
* unterschieden und entsprechend entschlsselt, die Syntax lautet:
*
*    * bel. Text                        Kommentar, wird bersprungen
*    I ,s1,s2,...,sn                    Steuersequenz fr Drucker
*    CR,n                               n mal Carriage Return
*    T ,x,Text                          Ausgabe des "Text" in der akt. Zeile
*                                            an Pos. x,
*                                            wenn "Text" = Standardtext,
*                                                        = Kalenderwoche 
*                                                        = Personalnummer,
*                                                        = Kostenstelle,
*                                                        = Name, dann Ausgabe
*                                            des entsprechenden Textes, sonst
*                                            beliebiger Text 
*    O ,x,Tag,Teil                      Ausgabe der Datum/Orts-Zeile ab Pos.
*                                            x, Teil 1-3 der Zeile
*    M ,x,Tag                           Ausgabe eines "M" an Pos. x, wenn "M"
*                                            an diesem Tag angeclickt war
*    F ,x,Tag                           Ausgabe eines "F" an Pos. x, wenn "F"
*                                            an diesem Tag angeclickt war
*    E ,x,Tag                           Ausgabe eines "E" an Pos. x, wenn "E"
*                                            an diesem Tag angeclickt war
*    Z ,x,Tag,Code,Picture              Ausgabe eines durch Code definierten
*                                            Zahlenwertes des Tages in einem
*                                            durch Picture def. Format
*    H ,x,Tag,Picture                   horizontale Tagessumme
*    V ,x,Code,Picture                  vertikale Spaltesumme
*    S ,x,Picture                       Gesamtsumme
*    @@@                                markieren des Fileende
*
*    akzeptiert werden:
*    eine Integerzahl > 0 fr x
*    1, 2 oder 3 fr Teil (der Datum/Ort-Zeile)
*    Mo,Di,Mi,Do,Fr,Sa,So fr Tag
*    Code = 0 sind die Kilometer
*    Code = 1 ist das KM-Geld
*    Code = 2 ist der Arbeitsbeginn   (h-von)
*    Code = 3 ist das Arbeitsende     (h-bis)
*    Code = 4 sind die Tagesspesen
*    Code = 5 sind die bernachtungskosten
*    Code = 6 sind Spesen nach Beleg
*    Code = 7 sind Nebenkosten
*    Picture ist mit # zu definieren, ein # steht fr eine Dezimalstelle
*        (###.## bedeutet z.B. 3 Vorkomma- und 2 Nachkommastellen)
*
* setzt EPSON-kompat. auf 12 CPI (ELITE)
I ,27,58
* und auf 8 LPI
I ,27,48
* und in KURSIV
I ,27,37,71
* 2 Zeilenvorschbe
CR,2
* Standardtext, Kostenstelle, Name, Personalnummer, Jahr, Kalenderwoche
T ,1,Standardtext
T ,15,Kostenstelle
T ,22,Name
T ,50,Personalnummer
T ,60,1990 - KW
T ,72,Kalenderwoche
* KURSIV wieder aus
I ,27,37,72
* 2 Zeilenvorschbe
CR,2
* +++++++++++++++++ der MONTAG ++++++++++++++++++
* Datum/Ortszeile, 1. Teil
O ,1,Mo,1
* Zahlenwerte KM,KM-DM,h-von,h-bis,Spesen,bern.,Sp.n.Beleg,sonst.,Summe
Z ,26,Mo,0,####
Z ,32,Mo,1,####.##
Z ,40,Mo,2,##.##
Z ,47,Mo,3,##.##
Z ,54,Mo,4,####.##
Z ,62,Mo,5,####.##
Z ,70,Mo,6,####.##
Z ,78,Mo,7,####.##
* Tagessumme
H ,88,Mo,####.##
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 2. Teil
O ,1,Mo,2
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 3. Teil
O ,1,Mo,3
* Mehrtagereisen, Frhstck, Essen
M ,20,Mo
E ,22,Mo
F ,24,Mo
* 2 Zeilenvorschbe
CR,2
* +++++++++++++++++ der DIENSTAG ++++++++++++++++++
* Datum/Ortszeile, 1. Teil
O ,1,Di,1
* Zahlenwerte KM,KM-DM,h-von,h-bis,Spesen,bern.,Sp.n.Beleg,sonst.,Summe
Z ,26,Di,0,####
Z ,32,Di,1,####.##
Z ,40,Di,2,##.##
Z ,47,Di,3,##.##
Z ,54,Di,4,####.##
Z ,62,Di,5,####.##
Z ,70,Di,6,####.##
Z ,78,Di,7,####.##
* Tagessumme
H ,88,Di,####.##
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 2. Teil
O ,1,Di,2
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 3. Teil
O ,1,Di,3
* Mehrtagereisen, Frhstck, Essen
M ,20,Di
E ,22,Di
F ,24,Di
* 2 Zeilenvorschbe
CR,2
* +++++++++++++++++ der MITTWOCH ++++++++++++++++++
* Datum/Ortszeile, 1. Teil
O ,1,Mi,1
* Zahlenwerte KM,KM-DM,h-von,h-bis,Spesen,bern.,Sp.n.Beleg,sonst.,Summe
Z ,26,Mi,0,#### 
Z ,32,Mi,1,####.##
Z ,40,Mi,2,##.##
Z ,47,Mi,3,##.##
Z ,54,Mi,4,####.##
Z ,62,Mi,5,####.##
Z ,70,Mi,6,####.##
Z ,78,Mi,7,####.##
* Tagessumme
H ,88,Mi,####.##
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 2. Teil
O ,1,Mi,2
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 3. Teil
O ,1,Mi,3
* Mehrtagereisen, Frhstck, Essen
M ,20,Mi
E ,22,Mi
F ,24,Mi
* 2 Zeilenvorschbe
CR,2
* +++++++++++++++++ der DONNERSTAG ++++++++++++++++++
* Datum/Ortszeile, 1. Teil
O ,1,Do,1
* Zahlenwerte KM,KM-DM,h-von,h-bis,Spesen,bern.,Sp.n.Beleg,sonst.,Summe
Z ,26,Do,0,####
Z ,32,Do,1,####.##
Z ,40,Do,2,##.##
Z ,47,Do,3,##.##
Z ,54,Do,4,####.##
Z ,62,Do,5,####.##
Z ,70,Do,6,####.##
Z ,78,Do,7,####.##
* Tagessumme
H ,88,Do,####.##
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 2. Teil
O ,1,Do,2
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 3. Teil
O ,1,Do,3
* Mehrtagereisen, Frhstck, Essen
M ,20,Do
E ,22,Do
F ,24,Do
* 2 Zeilenvorschbe
CR,2
* +++++++++++++++++ der FREITAG ++++++++++++++++++
* Datum/Ortszeile, 1. Teil
O ,1,Fr,1
* Zahlenwerte KM,KM-DM,h-von,h-bis,Spesen,bern.,Sp.n.Beleg,sonst.,Summe
Z ,26,Fr,0,####
Z ,32,Fr,1,####.##
Z ,40,Fr,2,##.##
Z ,47,Fr,3,##.##
Z ,54,Fr,4,####.##
Z ,62,Fr,5,####.##
Z ,70,Fr,6,####.##
Z ,78,Fr,7,####.##
* Tagessumme
H ,88,Fr,####.##
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 2. Teil
O ,1,Fr,2
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 3. Teil
O ,1,Fr,3
* Mehrtagereisen, Frhstck, Essen
M ,20,Fr
E ,22,Fr
F ,24,Fr
* 2 Zeilenvorschbe
CR,2
* +++++++++++++++++ der SAMSTAG ++++++++++++++++++
* Datum/Ortszeile, 1. Teil
O ,1,Sa,1
* Zahlenwerte KM,KM-DM,h-von,h-bis,Spesen,bern.,Sp.n.Beleg,sonst.,Summe
Z ,26,Sa,0,####
Z ,32,Sa,1,####.##
Z ,40,Sa,2,##.##
Z ,47,Sa,3,##.##
Z ,54,Sa,4,####.##
Z ,62,Sa,5,####.##
Z ,70,Sa,6,####.##
Z ,78,Sa,7,####.##
* Tagessumme
H ,88,Sa,####.##
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 2. Teil
O ,1,Sa,2
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 3. Teil
O ,1,Sa,3
* Mehrtagereisen, Frhstck, Essen
M ,20,Sa
E ,22,Sa
F ,24,Sa
* 2 Zeilenvorschbe
CR,2
* +++++++++++++++++ der SONNTAG ++++++++++++++++++
* Datum/Ortszeile, 1. Teil
O ,1,So,1
* Zahlenwerte KM,KM-DM,h-von,h-bis,Spesen,bern.,Sp.n.Beleg,sonst.,Summe
Z ,26,So,0,####
Z ,32,So,1,####.##
Z ,40,So,2,##.##
Z ,47,So,3,##.##
Z ,54,So,4,####.##
Z ,62,So,5,####.##
Z ,70,So,6,####.##
Z ,78,So,7,####.##
* Tagessumme
H ,88,So,####.##
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 2. Teil
O ,1,So,2
* ein Zeilenvorschub
CR,1
* Datum/Ortszeile, 3. Teil
O ,1,So,3
* Mehrtagereisen, Frhstck, Essen
M ,20,So
E ,22,So
F ,24,So
* 2 Zeilenvorschbe
CR,2
*** +++++++++++++++++ die Spaltensummen ++++++++++++++++++
V ,26,0,####
V ,32,1,####.##
V ,54,4,####.##
V ,62,5,####.##
V ,70,6,####.##
V ,78,7,####.##
* Gesamtsumme
S ,88,####.##
* 5 Zeilenvorschbe
CR,5
* @@@ markiert das Fileende und darf nicht gelscht werden
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
