* Dies ist die Steuerdatei zum Ausdruck einer Monatsabrechnung auf ein
* Formular. Die Angaben in den einzelnen Zeilen dieser Datei sind codiert
* und werden von Spesenprogramm eingelesen, decodiert und ausgefhrt.
* Die Zahlen sind im Modul "Monat - drucken" auf dem Monitor zu
* sehen. Daneben stehen noch einige Informationen codiert zur Verfgung.
* 
* Die einzelnen Zeilen dieser Datei werden anhand des 1. Zeichens
* unterschieden und entsprechend entschlsselt, die Syntax lautet:
*
*    * bel. Text                        Kommentar, wird bersprungen
*    I ,s1,s2,...,sn                    Steuersequenz fr Drucker
*    CR,n                               n mal Carriage Return
*    T ,x,Text                          Ausgabe des "Text" in der akt. Zeile
*                                            an Pos. x,
*                                            wenn "Text" = Standardtext,
*                                                        = Kalenderwoche 
*                                                        = Personalnummer,
*                                                        = Kostenstelle,
*                                                        = Name, 
*                                            dann Ausgabe des entsprechenden
*                                            Textes, sonst beliebiger Text 
*    D ,x,w                             Ausgabe des Dateinamens der Wochen (n-te.KW)
*                                            an Pos. x der aktuellen Zeile
*                                            w ist mit 0-4 zulssig, wobei
*                                            0 die erste Woche, 4 die letzte
*                                            der 5 mglichen ist. Die Anordnung
*                                            entspricht der Grafik unter
*                                            "Monat - Drucken"
*    W ,x,w,Code,Picture                Ausgabe eines durch "w" und Code definierten
*                                            Zahlenwertes und durch Picture def. Formats
*                                            an Pos. x der aktuellen Zeile
*                                            w ist mit 0-4 zulssig, wobei
*                                            0 die erste Woche, 4 die letzte
*                                            der 5 mglichen ist. Die Anordnung
*                                            entspricht der Grafik unter
*                                            "Monat - Drucken"
*                                            "Code" ist zulssig mit:
*                                            KMDM =    Kilometergeld
*                                            TS   =    Tagesspesen
*                                            NS   =    Nachtspesen
*                                            SNB  =    Spesen nach Beleg
*                                            NK   =    Nebenkosten
*                                            ZEIT =    Mehrarbeit
*                                            SUM  =    Summe                                            
*    G ,x,Code,Picture                  Ausgabe der durch  Code definierten
*                                            Gesamtsumme.
*                                            Picture def. das Format
*                                            Ausgabe an Pos. x d. akt. Zeile
*                                            "Code" ist zulssig mit:
*                                            KMDM =    Kilometergeld
*                                            TS   =    Tagesspesen
*                                            NS   =    Nachtspesen
*                                            SNB  =    Spesen nach Beleg
*                                            NK   =    Nebenkosten
*                                            ZEIT =    Mehrarbeit
*                                            SUM  =    Summe                                            
*                                            "G ,x,SUM,####.##" wre damit
*                                            gleich der Summe aller Einzelsummen.     
*    @@@                                markieren des Fileende
*
*    Picture ist mit # zu definieren, ein # steht fr eine Dezimalstelle
*        (###.## bedeutet z.B. 3 Vorkomma- und 2 Nachkommastellen)
*
* --------------------------------------------------------------------
*
* BEGINN DEFINITIONSTEIL
*
* setzt EPSON-kompat. auf 12 CPI (ELITE)
I ,27,58
* und auf 8 LPI
I ,27,48
* und in KURSIV
I ,27,37,71
* 2 Zeilenvorschbe
CR,2
* Monatsabrechnung Kostenstelle, Name, Personalnummer, Jahr, Kalenderwoche
T ,1,Monatsabrechnung
T ,18,Kostenstelle
T ,25,Name
T ,55,Personalnummer
T ,65,1991
* KURSIV wieder aus
I ,27,37,72
* 2 Zeilenvorschbe
CR,2
* Wochenauflistung und unterstreichen
T ,1,Monatsaufstellung
CR,1
T ,1,-----------------
CR,2
* Kalenderwoche und Filenamen und Summe
T ,1,Wochenauflistung
D ,17,0
D ,27,1
D ,37,2
D ,47,3
D ,57,4
T ,70,Summe
CR,1
T ,1,--------------------------------------------------------------------------
CR,1
* Kilometergeld und Werte und Summe
T ,1,Kilometergeld
W ,16,0,KMDM,#####.##
W ,26,1,KMDM,#####.##
W ,36,2,KMDM,#####.##
W ,46,3,KMDM,#####.##
W ,56,4,KMDM,#####.##
G ,66,KMDM,######.##
CR,1
* Tagesspesen und Werte und Summe
T ,1,Tagesspesen
W ,16,0,TS,#####.##
W ,26,1,TS,#####.##
W ,36,2,TS,#####.##
W ,46,3,TS,#####.##
W ,56,4,TS,#####.##
G ,66,TS,######.##
CR,1
* Nachtspesen und Werte und Summe
T ,1,Nachtspesen
W ,16,0,NS,#####.##
W ,26,1,NS,#####.##
W ,36,2,NS,#####.##
W ,46,3,NS,#####.##
W ,56,4,NS,#####.##
G ,66,NS,######.##
CR,1
* Spesen nach Beleg und Werte und Summe
T ,1,Spesen . Bel.
W ,16,0,SNB,#####.##
W ,26,1,SNB,#####.##
W ,36,2,SNB,#####.##
W ,46,3,SNB,#####.##
W ,56,4,SNB,#####.##
G ,66,SNB,######.##
CR,1
* Nebenkosten und Werte und Summe
T ,1,Nebenkosten
W ,16,0,NK,#####.##
W ,26,1,NK,#####.##
W ,36,2,NK,#####.##
W ,46,3,NK,#####.##
W ,56,4,NK,#####.##
G ,66,NK,######.##
CR,1
* Arbeitszeit (IST-SOLL) und Werte und Summe
T ,1,ZEIT=IST-SOLL
W ,16,0,ZEIT,#####.##
W ,26,1,ZEIT,#####.##
W ,36,2,ZEIT,#####.##
W ,46,3,ZEIT,#####.##
W ,56,4,ZEIT,#####.##
G ,66,ZEIT,######.##
CR,1
* Wochensummen und Werte und Gesamtsumme
T ,1,Wochensummen
W ,16,0,SUM,#####.##
W ,26,1,SUM,#####.##
W ,36,2,SUM,#####.##
W ,46,3,SUM,#####.##
W ,56,4,SUM,#####.##
G ,66,SUM,######.##
CR,1
T ,1,--------------------------------------------------------------------------
CR,1
* @@@ markiert das Fileende und darf nicht gelscht werden
@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@@
